xcraid.eqDKP = true

function xcraid:CreateEqXML(raidindex)
    local event = xcraid.db.account.events[raidindex]
	
    local text = "<RaidInfo>"
	local players = ""

	local tempdate = string.gsub(event.date, "%.", "%/") .. " 00:00:00"

	text = text .. "<key>" .. tempdate .. "</key>"
	text = text .. "<start>" .. tempdate .. "</start>"
	text = text .. "<end>" .. tempdate .. "</end>"
	text = text .. "<zone>" .. event.name .. "</zone>"
    local i = 0
	for name, member in pairs(event.raid.members) do
        if (member.gender) then gender = member.gender else gender = "3" end
        i = i + 1
        players = players .. "<key" .. i .. ">"
        players = players .. "<name>" .. name .. "</name>"
        players = players .. "<level>".."70".."</level>"
        players = players .. "<race>"..member.race.."</race>"
        players = players .. "<class>"..member.class.."</class>"
        players = players .. "<sex>".. gender.. "</sex>"
        players = players .. "<time>"..tempdate.."</time>"
        players = players .. "</key" .. i .. ">"        
	end

--[[
	text = text .. "<BossKills>"
	for i, v in ipairs(killedBosses) do
		text = text .. "<key" .. i .. "><name>" .. v .. "</name><time>" .. fdate .. "</time><attendees/></key" .. i .. ">"
	end
	text = text .. "</BossKills>"
--]]

	text = text .. "<PlayerInfos>".. players .. "</PlayerInfos>"
	text = text .. "<Note><![CDATA["..event.raid["zone"].. " - Zone: "..event.raid["zone"].." - Boss: Unknown]]></Note>"
	text = text .. "<Join>" .. players .. "</Join>"
	text = text .. "<Leave>" .. players .. "</Leave>"

	text = text .. "<Loot>"

	for k, item in ipairs(event.items) do
        itemLink = xcraid:GetItemLink(item.itemId)

        local _, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(item.itemId)
        local itemName = item.itemName
        if not itemLink then itemLink = " " end
        local id = string.match(itemLink, "^|%x+|Hitem:(.*)")
        local colorpart = string.match(itemLink, "^|(%x+)|")
        if not colorpart then colorpart = " " end
        local color = string.sub(colorpart, 2)

        text = text .. "<key" .. k .. ">"
        text = text .. "<ItemName>" .. itemName .. "</ItemName>"
        text = text .. "<ItemID>" .. id .. "</ItemID>"
        text = text .. "<Icon>".. itemTexture .."</Icon>"
        text = text .. "<Class>"..itemType.."</Class>"
        text = text .. "<SubClass>"..itemSubType.."</SubClass>"
        text = text .. "<Color>" .. color .. "</Color>"
        text = text .. "<Count>1</Count>"
        text = text .. "<Player>" .. item.looter .. "</Player>"
        text = text .. "<Time>" ..  tempdate .. "</Time>"
        text = text .. "<Zone>" .. event.raid.zone .. "</Zone>"
        text = text .. "<Boss>Unknown</Boss>"
        text = text .. "<Note><![CDATA["..event.raid["zone"].. " - Zone: "..event.raid["zone"].." - Boss: Unknown]]></Note>"
        text = text .. "</key" .. k .. ">"
	end

	text = text .. "</Loot>"
	text = text .. "</RaidInfo>"
	return text
end

function xcraid:PopupEqXML(raidindex)
    local text = xcraid:CreateEqXML(raidindex)
    StaticPopupDialogs["SHOW_URL"] = StaticPopupDialogs["SHOW_URL"] or {
        text = "EqDKP XML: ",
        button2 = ACCEPT,
        hasEditBox = 1,
        hasWideEditBox = 1,

        OnShow = function()
            this:SetWidth(420)
            
            local editBox = getglobal(this:GetName().."WideEditBox")
            editBox:SetText(StaticPopupDialogs["SHOW_URL"].urltext)
            editBox:SetFocus()
            editBox:HighlightText(0)

            local button = getglobal(this:GetName().."Button2")
            button:ClearAllPoints()
            button:SetWidth(200)
            button:SetPoint("CENTER", editBox, "CENTER", 0, -30)
        end,

        OnHide = function() end,
        OnAccept = function() end,
        OnCancel = function() end,
        EditBoxOnEscapePressed = function() this:GetParent():Hide() end,
        timeout = 0,
        whileDead = 1,
        hideOnEscape = 1
    }

    StaticPopupDialogs["SHOW_URL"].urltext = text
    StaticPopup_Show ("SHOW_URL", text)
end


