﻿xcraid = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0")
local L = AceLibrary("AceLocale-2.2"):new("xcRaid")
local Tablet = AceLibrary("Tablet-2.0")
local Dewdrop = AceLibrary("Dewdrop-2.0")



xcraid.pimps = {
	L["Chromatic Resistance"],
	L["Distilled Wisdom"],
	L["Flask of Fortification"],
	L["Flask of Mighty Restoration"],
	L["Flask of Relentless Assault"],
	L["Supreme Power"],
	L["Flask of the Titans"],
	L["Supreme Power of Shattrath"],
	L["Fortification of Shattrath"],
	L["Mighty Restoration of Shattrath"],
	L["Relentless Assault of Shattrath"],
	-- new for 2.2
	L["Flask of Pure Death"],
	L["Flask of Blinding Light"],
	L["Chromatic Wonder"],
  -- Gruul
  L["Unstable Flask of the Bandit"],
  L["Unstable Flask of the Beast"],
  L["Unstable Flask of the Elder"],
  L["Unstable Flask of the Physician"],
  L["Unstable Flask of the Soldier"],
  L["Unstable Flask of the Sorcerer"],
  L["Fel Strength Elixir"],
  L["Onslaught Elixir"],
  L["Major Strength"],
  L["Elixir of Major Strength"],
  L["Major Agility"],
  L["Elixir of Major Agility"],
  L["Elixir of Mastery"],
  L["Major Firepower"],
  L["Elixir of Major Firepower"],
  L["Major Shadow Power"],
  L["Elixir of Major Shadow Power"],
  L["Major Frost Power"],
  L["Elixir of Major Frost Power"],
  L["Adept's Elixir"],
  L["Arcane Elixir"],
  L["Greater Arcane Elixir"],
  L["Healing Power"],
  L["Elixir of Healing Power"],
  L["Elixir of the Mongoose"],
  L["Major Armor"],
  L["Elixir of Major Defense"],
  L["Greater Armor"],
  L["Elixir of Superior Defense"],
  L["Greater Mana Regeneration"],
  L["Elixir of Major Mageblood"],
  L["Mana Regeneration"],
  L["Mageblood Potion"],
  L["Earthen Elixir"],
  L["Elixir of Draenic Wisdom"],
  L["Elixir of Major Fortitude"],
  L["Elixir of Empowerment"],
  L["Empowerment"],
  L["Elixir of Ironskin"],
  L["Elixir of Greater Firepower"],
  L["Well Fed"]
}



xcraid.name = "xcRaid"
xcraid.hasIcon = true
xcraid.clickableTooltip = true
xcraid.independentProfile = true
xcraid.qualityString = {}


xcraid.options = {
	type = "group",
	args = {
        autoEvent = {
            type = "group",
            name = L["auto raid"],
            desc = L["select wether to add a new raid on certain situations"],
            order = 1,
            args = {
                zone = {
                    type = "toggle",
                    name = L["new zone"],
                    desc = L["add a raid when loot gets tracked in a new zone"],
                    get = function() return xcraid.db.account.autoEvent end,
                    set = function() 
                            xcraid.db.account.autoEvent = not xcraid.db.account.autoEvent
                            if (xcraid.db.account.autoEventBoss) then xcraid.db.account.autoEventBoss = false end
                        end,
                },
                boss = {
                    type = "toggle",
                    name = L["boss death"],
                    desc = L["add a raid when a boss dies (ie. to track buffs)"],
                    get = function() return xcraid.db.account.autoEventBoss end,
                    set = function() 
                            xcraid.db.account.autoEventBoss = not xcraid.db.account.autoEventBoss
                            if (xcraid.db.account.autoEvent) then xcraid.db.account.autoEvent = false end
                        end,
                    disabled = true,
                },                
            },
        },
        addEvent = {    
            type = "text",
            name = L["new event"],
            desc = L["new event"],
            get = false,
            set = function(text)
                xcraid.db.account.currentEvent = xcraid.AddEvent(self, text, date("%d.%m.%y"))
            end,
            usage = L["specify a name for the event"],
            order = 2,
        },
		raidOnly = {
			type = "toggle",
			name = L["track groups"],
			desc = L["track items in groups, too"],
			get = function() return not xcraid.db.account.raidOnly end,
			set = function() xcraid.db.account.raidOnly = not xcraid.db.account.raidOnly end,
		},
		deleteEvent = {
			type = "group",
			desc = L["delete a raid"],
			name = L["delete raid"],
			args = {			
			},
		},
        trackRarity = {
            type = "group",
            name = L["Rarity"],
            desc = L["choose which items to track"],
            args = {
                clearOtherRarity = {
                    type = "execute",
                    name = L["remove Trash"],
                    desc = L["clears already tracked Items with other rarity than specified. This can not be undone!"],
                    func = "ClearOtherRarity",
                    handler = xcraid,
                    disabled = true
                }
            },           
        },
        ignoredItems = {
            type = "group",
            name = L["ignored items"],
            desc = L["these items are ignored. use /xcr ignore [itemlink] to ignore an item"],
            args = {
            },
        },
        mode = {
            type = "group",
            name = L["DKP Mode"],
            desc = L["choose between Item-Split and Item-Division"],
            args = {
                split = {
                    type = "toggle",
                    name = L["Item-Split"],
                    desc = L["DKP-costs are split to the other raidmembers"],
                    get = function() return xcraid.db.account.splitMode end,
                    set = function() xcraid.db.account.splitMode = not xcraid.db.account.splitMode end,
                },
                division = {
                    type = "toggle",
                    name = L["Item-Division"],
                    desc = L["Item-Division mode"],
                    get = function() return not xcraid.db.account.splitMode end,
                    set = function() xcraid.db.account.splitMode = not xcraid.db.account.splitMode end,
                },
            },
            --disabled = true,
        },
        eqdkp = {
            hidden = function() return not xcraid.eqDKP end,
            type = "group",
            desc = L["lets you Copy & Paste a XML-String to export Raid data"],
            name = L["export Raid (XML)"],
            args = {			
            }
        },
        spacer1 = {
            type = "header",
            order = 200
        },     
    }
}


function xcraid:RemoveThese(removeThese)
    local count = 0    
    for k = #removeThese, 1, -1 do 
    -- reverse order to avoid problems due to reindexing done through table.remove
        local i, j = removeThese[k][1], removeThese[k][2]
        table.remove(xcraid.db.account.events[i].items, j)
        count = count + 1
    end
    xcraid:Print(string.format(L["%d items removed."], count))
    xcraid:UpdateTooltip()
end

function xcraid:ClearOtherRarity()
    local removeThese = {}
    -- be sure all Items are in the game's cache
    for i , event in pairs(xcraid.db.account.events) do
        for j, item in pairs(xcraid.db.account.events[i].items) do
            xcraid:GetItemLink(item.itemId) 
        end 
    end
    for i , event in pairs(xcraid.db.account.events) do
        for j, item in pairs(xcraid.db.account.events[i].items) do
            local itemId = item.itemId
            
            local _, _, itemRarity = GetItemInfo(itemId)
            if not xcraid:IsTracked(itemRarity) then
                tinsert(removeThese, {i, j})
            end
        end
    end
    xcraid:RemoveThese(removeThese)
end

function xcraid:ClearIgnored()
    local removeThese = {}
    for i , event in pairs(xcraid.db.account.events) do
        for j, item in pairs(xcraid.db.account.events[i].items) do
            local itemId = item.itemId
            if self.db.account.ignoredItems[itemId] then
                tinsert(removeThese, {i, j})
            end
        end
    end
    xcraid:RemoveThese(removeThese)
end

function xcraid:IsTracked(i)
    return xcraid.db.account.track[i]
end

function xcraid:ToggleTracked(i)
    xcraid.db.account.track[i] = not xcraid.db.account.track[i]
end

function xcraid:OnInitialize()
    
    xcraid:RegisterDB("xcRaidSV")
    xcraid:RegisterDefaults("account", {
        currentEvent = 1,
        events = {},
        raidOnly = true,
        trackLegendary = true,
        track = {true, true, true, true, true},
        autoEvent = true,
        autoEventBoss = false,
        showMembers = false,
        ignoredItems = {
            ["29434"] = true, -- Badge of Justice
            ["30319"] = true, -- Nether Spike
            ["30318"] = true, -- Netherstrand Longbow
            ["30313"] = true, -- Staff of Disintegration
            ["30316"] = true, -- Devastation
            ["30319"] = true, -- Nether Spike
            ["30317"] = true, -- Cosmic Infuser
            ["30314"] = true, -- Phaseshift Bulwark
            ["30312"] = true, -- Infinity Blade
            ["30311"] = true, -- Warp Slicer
        },
        splitMode = false,
        locale = GetLocale(),
    })
    
    for i = 1, 4 do
        _, _, _, hex = GetItemQualityColor(i)
        xcraid.qualityString[i] = hex..getglobal("ITEM_QUALITY"..i.."_DESC").."|r"
        table.insert(xcraid.options.args.trackRarity.args, {
            type = "toggle", 
            name = xcraid.qualityString[i],
            desc = string.format(L["track %s items"], xcraid.qualityString[i]),
            get = "IsTracked",
            set = "ToggleTracked",
            handler = xcraid,
            passValue = i,
            order = i
        })
    end

    xcraid:SetIcon("Interface\\Addons\\xcraid\\icon")
    
    local ignore = {
        type = "group", args = {
            ignore = {
                type = "text", 
                name = "ignore", 
                desc = L["append item to ignore"], 
                get = false, 
                set = "AddIgnoreItem", 
                usage = "[Itemlink]"
            }
        }
    }
    xcraid:RegisterChatCommand("/xcr", "/xcraid", ignore, "XCRAID")
    xcraid.RAID_JOIN_PATTERN = string.gsub(ERR_RAID_MEMBER_ADDED_S, "%%s", "%^%(%.%+%)")
    xcraid.RAID_LEAVE_PATTERN = string.gsub(ERR_RAID_MEMBER_REMOVED_S, "%%s", "%^%(%.%+%)")
end

function xcraid:AddIgnoreItem(itemLink)
    itemId = string.match(itemLink, ".+item:(%d+):.+") or string.match(itemLink, "^(%d+)$")
    if itemId then
        xcraid.db.account.ignoredItems[itemId] = true
    end
end

function xcraid:RemoveIgnoredItem(itemId)
    xcraid.db.account.ignoredItems[string.format("%d", itemId)] = false
end

function xcraid:RemoveEvent(eventId)
    table.remove(xcraid.db.account.events, eventId)
    xcraid:UpdateTooltip()
end

function xcraid:OnEnable()
    xcraid:RegisterEvent("CHAT_MSG_LOOT")
    xcraid:RegisterEvent("CHAT_MSG_SYSTEM")    
end

function xcraid:OnDoubleClick()
    xcraid:PopupAddEvent()
end

function xcraid:GetItemLink(itemId)
    _, itemLink = GetItemInfo(itemId)
    -- query server if not cached
    if not itemLink then
        GameTooltip:SetHyperlink("item:"..itemId..":0:0:0:0:0:0:0")
        _, itemLink = GetItemInfo(itemId)
    end
    return itemLink
end

function xcraid:OnMenuRequest()
	xcraid.options.args.deleteEvent.args = {}
	xcraid.options.args.eqdkp.args = {}
    
    table.insert(xcraid.options.args.deleteEvent.args, {
			type = "execute",
			name = L["clear"],
			desc = L["delete all events"],
			func = function() 
    			xcraid.db.account.events = {}
                xcraid:UpdateTooltip()
			end,
            confirm = true,
            order = 01
		})
	for i, event in ipairs(self.db.account.events) do
		table.insert(xcraid.options.args.deleteEvent.args, {
			type = "execute",
			name = event.date.." "..event.name,
			desc = string.format(L["delete %q on %s"], event.name, event.date),
			func = "RemoveEvent",
			passValue = i,
            handler = xcraid
		})
		table.insert(xcraid.options.args.eqdkp.args, {
			type = "execute",
			name = event.date.." "..event.name,
			desc = string.format(L["export %q on %s"], event.name, event.date),
			func = "PopupEqXML",
			passValue = i,
            handler = xcraid
		})        
	end
    
    xcraid.options.args.ignoredItems.args = {}
    for itemId, v in pairs(xcraid.db.account.ignoredItems) do 
        itemLink = xcraid:GetItemLink(itemId)
        if v then
            table.insert(xcraid.options.args.ignoredItems.args, {
                type = "execute",
                name = itemLink or itemId,
                desc = L["click to not longer ignore this item"],
                func = "RemoveIgnoredItem",
                passValue = itemId,
                handler = xcraid
            })
        end
    end
    table.insert(xcraid.options.args.ignoredItems.args, {
        type = "execute",
        name = L["remove ignored Items"],
        desc = L["clears already tracked Items which are ignored from all Raids. This can not be undone!"],
        func = "ClearIgnored",
        handler = xcraid,       
    }) 
	Dewdrop:FeedAceOptionsTable(xcraid.options)
end

function xcraid:CloseEvents(omit)
    for i, event in ipairs(xcraid.db.account.events) do
        if i ~= omit then
            event.open = false
        end
    end    
end

function xcraid:CHAT_MSG_SYSTEM()
    local raid
    if xcraid.db.account.currentEvent then
        raid = xcraid.db.account.events[xcraid.db.account.currentEvent].raid
    else 
        return
    end
    
    local name = string.match(arg1, xcraid.RAID_JOIN_PATTERN)
    if name then
        if not raid[name] then raid[name] = xcraid:ScanMember(name) end
        if not raid[name].join then raid[name].join = {} end
        table.insert(raid[name].join, string.format("%d:%d", GetGameTime()))
        return
    end
    local name = string.match(arg1, xcraid.RAID_LEAVE_PATTERN)
    if name then
        if not raid[name] then raid[name] = xcraid:ScanMember(name) end
        if not raid[name].leave then raid[name].leave = {} end
        table.insert(raid[name].leave, string.format("%d:%d", GetGameTime()))
        return
    end
    name = nil
end

function xcraid:CHAT_MSG_LOOT()
    if GetNumRaidMembers() == 0 and xcraid.db.account.raidOnly then return end

    --[[ testing purposes only
    itemId = string.match(arg1, L["You receive item: .+item:(%d+):.+[x%d+]*\."])
    
    if itemId then
        itemName, _, itemRarity = GetItemInfo(itemId);
        
        if xcraid:IsTracked(itemRarity) and not xcraid.db.account.ignoredItems[itemId] then
            xcraid:AddItemToEvent(itemId, itemName, UnitName("player"), xcraid.db.account.currentEvent)
            xcraid:UpdateTooltip()
        end
        return
    end
    --]]
	-- actual loot tracking
    itemId = string.match(arg1, L["You receive loot: .+item:(%d+):.+[x%d+]*\."])
    if itemId then
        itemName, _, itemRarity = GetItemInfo(itemId);
        if xcraid:IsTracked(itemRarity) and not xcraid.db.account.ignoredItems[itemId] then
            xcraid:AddItemToEvent(itemId, itemName, UnitName("player"), xcraid.db.account.currentEvent)
            xcraid:UpdateTooltip()
        end
        return
    else
        playerName, itemId = string.match(arg1, L["(.+) receives loot: .+item:(%d+):.+[x%d+]*\."])
        if itemId then
            itemName, _, itemRarity = GetItemInfo(itemId);
            if xcraid:IsTracked(itemRarity) and not xcraid.db.account.ignoredItems[itemId] then
                xcraid:AddItemToEvent(itemId, itemName, playerName, xcraid.db.account.currentEvent)
                xcraid:UpdateTooltip()
            end
            return                
        end
    end


    
end

function xcraid:AddEventAuto()
    local name = GetRealZoneText();
    local date = date("%d.%m.%y");
    xcraid.db.account.currentEvent = xcraid:AddEvent(name, date)
end

function xcraid:AddEvent(name, date)
    local thisRaid = xcraid:ScanRaid()
    
    table.insert(xcraid.db.account.events, {
        open = true, 
        name = name, 
        date = date, 
        items = {}, 
        raid = thisRaid, 
        zone = GetRealZoneText()
    })
    
    xcraid:CloseEvents(#xcraid.db.account.events)
    return #xcraid.db.account.events
end

function xcraid:AddItemToEvent(itemId, itemName, looter, eventid)
    if not eventid or 
    not #xcraid.db.account.events or #xcraid.db.account.events < eventid or
    (xcraid.db.account.events[eventid].name ~= GetRealZoneText() and xcraid.db.account.autoEvent) then 
        xcraid:AddEventAuto()
        eventid = xcraid.db.account.currentEvent
    end
    table.insert(xcraid.db.account.events[eventid].items, {itemId = itemId, itemName = itemName, looter = looter, dkp = "click to set"})    
end

function xcraid:EditDKP(eventid, itemindex, dkp)
    xcraid.db.account.events[eventid].items[itemindex].dkp = dkp
    xcraid:UpdateEventDKP(eventid)
    xcraid:UpdateTooltip()
end

function xcraid:EditCorrection(eventid, memberid, value)
    xcraid.db.account.events[eventid].raid.members[memberid].correction = value
    xcraid:UpdateTooltip()
end

function xcraid:EditCorrectionNote(eventid, memberid, value)
    xcraid.db.account.events[eventid].raid.members[memberid].note = value
    xcraid:UpdateTooltip()
end

function xcraid:PopupCorrectionEdit(eventid, memberid)
    local memberName = xcraid.db.account.events[eventid].raid.members[memberid].name
	if not Dewdrop:IsOpen(GetMouseFocus()) then
		Dewdrop:Close()
        Dewdrop:Open(GetMouseFocus(), "children", 
            function()
                Dewdrop:AddLine(
                    'text', memberName,
                    'isTitle', true
                )
                Dewdrop:AddLine(
                    'text', L["Correction"],
                    'hasArrow', true,
                    'hasEditBox', true,
                    'editBoxFunc', function(text)
                        xcraid.EditCorrection(self, eventid, memberid, text)
                        Dewdrop:Close()
                    end,
                    'editBoxValidateFunc', function(text)
                        -- no spaces, only numbers, negative allowed
                        return string.match(text, "^-?%d+$")
                    end,
                    'editBoxText', xcraid.db.account.events[eventid].raid.members[memberid].correction or ""
                )
                Dewdrop:AddLine(
                    'text', L["Notes"],
                    'hasArrow', true,
                    'hasEditBox', true,
                    'editBoxFunc', function(text)
                        xcraid.EditCorrectionNote(self, eventid, memberid, text)
                        Dewdrop:Close()
                    end,
                    'editBoxText', xcraid.db.account.events[eventid].raid.members[memberid].note or ""
                )
            end
        )
    else
        Dewdrop:Close();
    end
end

function xcraid:UpdateEventDKP(eventid)

    if not xcraid.db.account.splitMode then return end
    event = xcraid.db.account.events[eventid]
    local sum = 0
    for i, item in ipairs(event.items) do
        if item.dkp == L["click to set"] then itemdkp = 0 else itemdkp = item.dkp end
        sum = sum + itemdkp
    end
    local count = 0
    for k, v in pairs(event.raid.members) do
        count = count + 1
    end
    xcraid:Print(sum, count)
    xcraid.db.account.events[eventid].eventDKP = math.floor((sum / count) + 0.5)

end

function xcraid:AddEventDetails(eventid, cat)
    event = xcraid.db.account.events[eventid]
    if xcraid.db.account.showMembers then
        for j, member in pairs(event.raid.members) do
            if not member.class then member.class = "PRIEST" end
            cat:AddLine(
                "text", member.name,
                "textR", RAID_CLASS_COLORS[string.upper(member.class)].r,
                "textB", RAID_CLASS_COLORS[string.upper(member.class)].b,
                "textG", RAID_CLASS_COLORS[string.upper(member.class)].g,
                "text3", member.correction or "",
                "func", "PopupCorrectionEdit",
                "arg1", self,
                "arg2", eventid,
                "arg3", j
                )
            for i, item in pairs(event.items) do
                if item.looter == member.name then
                    cat:AddLine(
                        'indentation', 30,
                        'text', item.itemName,
                        'text3', item.dkp,
                        'func', "PopupDKPEdit",
                        'arg1', self,
                        'arg2', eventid,
                        'arg3', i              
                    )
                end
            end -- for item
        end -- for member
    else
        for j, item in ipairs(event.items) do
            
            cat:AddLine(
                'text', item.itemName,
                'text2', item.looter,
                --[["text2R", RAID_CLASS_COLORS[string.upper(event.raid.members[item.looter].class)].r,
                "text2B", RAID_CLASS_COLORS[string.upper(event.raid.members[item.looter].class)].b,
                "text2G", RAID_CLASS_COLORS[string.upper(event.raid.members[item.looter].class)].g,                  --]]
                'text3', item.dkp,
                'func', "PopupDKPEdit",
                'arg1', self,
                'arg2', eventid,
                'arg3', j
            )
        end              
    end

end

function xcraid:BuildTablet()
    for i, event in ipairs(xcraid.db.account.events) do
        local cat = Tablet:AddCategory(
            'columns', 3,
            'text', event.date .. ' ' .. event.name,
            'text3', event.eventDKP or "0",
            'justify', "LEFT",
            'justify3', "RIGHT",
            'checked', true, 
            'hasCheck', true, 
            'showWithoutChildren', true,
            'checkIcon', event.open and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up",
            'func', "ToggleEvent",
            'arg1', self,
            'arg2', i,
            'child_indentation', 20,
            'hideBlankLine', true
        )
        if event.open then
            xcraid:AddEventDetails(i, cat)
        end
    end
end

function xcraid:ToggleEvent(id)

    if IsAltKeyDown() and not Dewdrop:IsOpen(GetMouseFocus()) then
		local event = xcraid.db.account.events[id]
        Dewdrop:Close()
        Dewdrop:Open(GetMouseFocus(), "children", 
            function()
                Dewdrop:AddLine(
                    'text', event.date .. " " .. event.name,
                    'isTitle', true
                )            
                Dewdrop:AddLine(
                    'text', "DKP",
                    'hasArrow', true,
                    'hasEditBox', true,
                    'editBoxFunc', function(text)
                        xcraid.db.account.events[id].eventDKP = text
                    end,
                    'editBoxValidateFunc', function(text)
                        -- no spaces, only numbers, negative allowed
                        return string.match(text, "^%d+$")
                    end
                )
                Dewdrop:AddLine(
                    'text', L["Name"],
                    'hasArrow', true,
                    'hasEditBox', true,
                    'editBoxFunc', function(text)
                        xcraid.db.account.events[id].name = text
                    end
                )                
                Dewdrop:AddLine(
                    'text', L["Balance"],
                    'hasArrow', true,
                    'hasEditBox', true,
                    'editBoxFunc', function(text)
                        xcraid.db.account.events[id].balance = text
                    end
                )  
                Dewdrop:AddLine(
                    'text', L["delete"],
                    'func', "RemoveEvent",
                    'arg1', xcraid,
                    'arg2', id
                )                    

            end
        )
    else
        xcraid:CloseEvents(id)
        xcraid.db.account.events[id].open = not xcraid.db.account.events[id].open
        xcraid:UpdateTooltip()
    end
end

function xcraid:PopupAddEvent()
	if not Dewdrop:IsOpen(GetMouseFocus()) then
		Dewdrop:Close()
        Dewdrop:Open(GetMouseFocus(), "children", 
            function()
                Dewdrop:AddLine(
                    'text', L["new event"],
                    'hasArrow', true,
                    'hasEditBox', true,
                    'editBoxFunc', function(text)
                        xcraid.db.account.currentEvent = xcraid.AddEvent(self, text, date("%d.%m.%y"))
                        Dewdrop:Close()
                    end
                )
            end
        )
    else
        Dewdrop:Close();
    end
end

function xcraid:OnClick()
    local eventid = xcraid.db.account.currentEvent
    if not eventid or not #xcraid.db.account.events or #xcraid.db.account.events < eventid then 
        return
    end
    local lastItem = #xcraid.db.account.events[eventid].items
    if lastItem > 0 then
        while xcraid.db.account.events[eventid].items[lastItem].dkp ~= "click to set" do
            lastItem = lastItem - 1
            if lastItem < 1 then return end
        end
        xcraid:PopupDKPEdit(eventid,lastItem)
    end
end

function xcraid:PopupDKPEdit(eventid, itemindex)
    local itemName = xcraid.db.account.events[eventid].items[itemindex].itemName
    local itemId = xcraid.db.account.events[eventid].items[itemindex].itemId
    
	if not Dewdrop:IsOpen(GetMouseFocus()) then
		Dewdrop:Close()
        Dewdrop:Open(GetMouseFocus(), "children", 
            function()
                Dewdrop:AddLine(
                    'text', itemName,
                    'isTitle', true
                )              
                Dewdrop:AddLine(
                    'text', "DKP",
                    'hasArrow', true,
                    'hasEditBox', true,
                    'editBoxFunc', function(text)
                        xcraid.EditDKP(self, eventid, itemindex, text)
                        Dewdrop:Close()
                    end,
                    'editBoxValidateFunc', function(text)
                        -- no spaces
                        return string.match(text, "^%d+$")
                    end
                )            
                Dewdrop:AddLine(
                    'text', L["ignore this Item"],
                    'func', xcraid.AddIgnoreItem,
                    'arg1', self,
                    'arg2', itemId
                )
            end
        )
    else
        Dewdrop:Close();
    end
end


function xcraid:OnTooltipUpdate()
    local toggleString
    if xcraid.db.account.showMembers then
        toggleString = L["raids"]
    else
        toggleString = L["members"]
    end

    xcraid:BuildTablet() 
        
    local cat = Tablet:AddCategory(
        'columns', 1,
        'showWithoutChildren', true,
        'text', string.format(L["Click here to show %s"], toggleString),
        'func', function() xcraid.db.account.showMembers = not xcraid.db.account.showMembers end
    )

  Tablet:SetHint(L["tooltip_hint"])
end

function xcraid:ScanRaid()

	local thisRaid = {members = {}}
	thisRaid.zone = GetRealZoneText()
    
	for memberId = 1, GetNumRaidMembers() do
        local member
        member = xcraid:ScanMember("raid"..memberId)
        thisRaid.members[member.name] = member		
	end
	return thisRaid
end

function xcraid:GetRaidId(unitId)
--xcraid:Print(unitId)
    local raidId = string.match(unitId, "(%d+)")
    if not raidId then
        for i = 1, MAX_RAID_MEMBERS do 
            if unitId == UnitName("raid"..i) then 
                return i
            end
        end
    else 
        return raidId
    end
    return false
end

function xcraid:ScanMember(unitId)
    local member
    local buffs = {}
    local i = 1

    while UnitBuff(unitId, i) do
        local name, rank, texture = UnitBuff(unitId, i)
        -- only add specified buffs to the list
        for i, pimpname in ipairs(xcraid.pimps) do 
            if (name == pimpname) then
                table.insert(buffs, 
                    {
                    name = name, 
                    texture = texture
                    }
                )
            end
        end
        i = i + 1
    end
    
    local guild = GetGuildInfo(unitId)
    local race = UnitRace(unitId)	
    local gender = UnitSex(unitId)        
    local raidId = xcraid:GetRaidId(unitId)
    
    local name, rank, subgroup 
    if raidId then name, rank, subgroup = GetRaidRosterInfo(raidId) end
    local _, class = UnitClass(unitId)
    
    
    member = {
        name = name,
        guild = guild,
        rank = rank,
        group = subgroup,
        class = class,
        race = race,
        gender = gender,
        buffs = buffs,
        open = false
        }	
    
    return member

end

function xcraid:RaidInCombat()
	for i = 1, GetNumRaidMembers() do
		if UnitAffectingCombat("raid"..i) then 
			return true
		end
	end
	return false
end

function xcraid:BossAttempt()
	for i = 1, GetNumRaidMembers() do
		local unit = "raid"..i.."target"
		local class = UnitClassification(unit)
		
		if class == "worldboss" 
		and not (UnitIsCorpse(unit) 
		or UnitIsDead(unit)) then
			local name = UnitName(unit)
			--self:Print("BossAttempt: "..name)
			return name
		end		
	end
	return false
end

function xcraid:RaidIsWiped()
	local bodyCount = 0;
	for i = 1, GetNumRaidMembers() do
		if UnitIsDeadOrGhost("raid"..i) or not UnitIsConnected("raid"..i)then 
			bodyCount = bodyCount + 1
			--xcraid:Print(bodyCount, i)
		end
	end
	if bodyCount == GetNumRaidMembers() then 
		self:Print(L["Wipe registered."])
		return true
	else
		return false
	end
end

function xcraid:BossIsDead()
	for i = 1, GetNumRaidMembers() do
		local unit = "raid"..i.."target"
		local class = UnitClassification(unit)
		
		if class == "worldboss" 
		and (UnitIsCorpse(unit) or UnitIsDead(unit)) then
			local name = UnitName(unit)
			self:Print(string.format(L["%s defeated."], name))
			return name
		end		
	end
	return false	
end

